package com.holmos.webtest.element.tool;

import com.holmos.webtest.constvalue.ConstValue;
import com.holmos.webtest.element.ListElement;
import com.holmos.webtest.element.locator.Locator;
import com.holmos.webtest.element.locator.LocatorChain;
import com.holmos.webtest.element.locator.LocatorValue;

/**
 * 用来判断数据结构是否存在的工具类
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class WebElementExist {
	protected LocatorValue webElement;
	protected LocatorChain infoChain;
	protected Locator locator;
	public WebElementExist(LocatorValue webElement){
		this.webElement=webElement;
		this.infoChain=webElement.getInfoChain();
		this.locator=webElement.getLocator();
	}
	protected void initComment(){
		StringBuilder commentTemp=new StringBuilder();
		for(int i=0;i<infoChain.getInfoNodes().size();i++){
			commentTemp.append(infoChain.getInfoNodes().get(i).getComment()+"-->");
		}
		if(webElement instanceof ListElement)
			commentTemp.append(((ListElement)webElement).getComment());
		else
			commentTemp.append(webElement.getComment());
		webElement.setWholeComment(commentTemp.toString());
	}
	/**
	 * 自己设置等待次数，一次50ms
	 * @param WaitCount 等待次数
	 * */
	public boolean isElementExist(int WaitCount){
		return false;
	}
	/**只等待一次*/
	public boolean isElementExistForCheckOnce(){
		return false;
	}
	public int getListElementSize(){
		return ConstValue.ERROR;
	}
	public int getCollectionSize(){
		return ConstValue.ERROR;
	}
	
}
