package com.holmos.webtest.junitextentions.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 此方法在运行时候用，并且强制是方法级别的注解，带有此注解的方法表示此方法应该在注解中指定的方法名之后运行
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface RunAfter {
	String methodName() default "";
}
