package com.holmos.webtest.junitextentions.excute;

import java.util.ArrayList;

import org.junit.runner.notification.RunNotifier;

import com.holmos.webtest.junitextentions.parameters.HolmosFrameWorkMethod;
import com.holmos.webtest.junitextentions.parameters.RunCountFrameWorkMethod;
import com.holmos.webtest.junitextentions.threadpool.HolmosThreadPoolExecutor;
/**
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class MethodRunner {
	/**代执行的方法*/
	private HolmosFrameWorkMethod method;
	private Object target;
	private RunNotifier notifier;
	public MethodRunner(HolmosFrameWorkMethod method,Object target,
			ArrayList<Object[]>parameters,RunNotifier notifier){
		this.method=method;
		this.target=target;
		this.notifier=notifier;
	}
	
	public void runHolmosMethod(){
		if(method.getRuncount()==1){
			//不分配线程池，就在当前所在线程执行
			method.getRunCountFrameWorkMethods().get(0).runParameterMethod(target,notifier);
		}else{
			//分配线程池进行执行
			HolmosThreadPoolExecutor execute=(HolmosThreadPoolExecutor)new HolmosThreadPoolExecutor(method.getRuncountThreadpoolSize(),method.getRuncount());
			for(int i=0;i<method.getRuncount();i++){
				RunCountMethodRunner runCountMethodRunner=new RunCountMethodRunner(method.getRunCountFrameWorkMethods().get(i),notifier);
				execute.submit(runCountMethodRunner);
			}
			execute.waitForCompleted();
		}
		method.notifySuccessorMethods();
	}
	class RunCountMethodRunner implements Runnable{
		private RunCountFrameWorkMethod runCountFrameWorkMethod;
		private RunNotifier notifier;
		public RunCountMethodRunner(RunCountFrameWorkMethod runCountFrameWorkMethod,RunNotifier notifier){
			this.runCountFrameWorkMethod=runCountFrameWorkMethod;
			this.notifier=notifier;
		}
		@Override
		public void run() {
			runCountFrameWorkMethod.runParameterMethod(target,notifier);
		}
	}
}
