package com.holmos.webtest.junitextentions.parameters.excel;

import java.util.ArrayList;

import org.apache.poi.ss.usermodel.Row;

import com.holmos.webtest.log.MyLogger;
/**
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class HolmosRow {
	MyLogger logger=MyLogger.getLogger(HolmosRow.class);
	private Row row;
	public HolmosRow(Row row){
		this.row=row;
	}
	
	/**
	 * 获取有效的列数
	 * */
	public int getValidColumnCount(){
		return row.getLastCellNum()-row.getFirstCellNum();
	}
	/**
	 * 根据列号来获取Cell
	 * */
	public HolmosCell getCellByIndex(int index){
		if(index<getValidColumnCount()){
			return new HolmosCell(row.getCell(index));
		}else{
			logger.error("要获取的单元格不行在!");
			return null;
		}
	}
	/**
	 * 获取此数据行所有的有效cell单元格信息
	 * */
	public ArrayList<HolmosCell>getValidCells(){
		ArrayList<HolmosCell>validCells=new ArrayList<HolmosCell>();
		for(int i=row.getFirstCellNum();i<row.getLastCellNum();i++){
			validCells.add(new HolmosCell(row.getCell(i)));
		}return validCells;
	}
	/**
	 * 获取此数据行所有的有效cell单元格的值
	 * */
	public ArrayList<Object>getValidValues(){
		ArrayList<Object>validCells=new ArrayList<Object>();
		for(int i=row.getFirstCellNum();i<row.getLastCellNum();i++){
			validCells.add(new HolmosCell(row.getCell(i)).getValueAsString());
		}return validCells;
	}
}
